case $CONFIG in
'')
    if test ! -f config.sh; then
        ln ../config.sh . || \
        ln ../../config.sh . || \
        ln ../../../config.sh . || \
        (echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac

case "$subdir" in
'')
    case "$0" in
    */*) cd `expr X$0 : 'X\(.*\)/'` ;;
    esac

    vpathdef="#VPATH = "
    XXsrcroot="."
    regarg=
    ;;
*)
    vpathdef="VPATH = $source_dir/$subdir"
    XXsrcroot="$source_dir"
    regarg="-A \"$source_dir/\""
    ;;
esac

vardir=`dirname $stage_dir`  

case "$d_locale" in
define)
	localetarget='$(ETC)/elm.mimecharsets $(ETC)/elm.terminalinfo'
	;;
*)
	localetarget=
	;;
esac

echo "Extracting Makefile-1 (with variable substitutions)"
cat >Makefile-1 <<!GROK!THIS!
#!$make
# $Id: Makefile-1.SH,v 2.3 2011-03-06 19:52:57 hurtta Exp $
#
#
#  Makefile for the ELM (ME+) mail program.
#
#  Author: Kari Hurtta <hurtta+elm@siilo.FMI.FI> 
#  	   	   (was hurtta+elm@posti.FMI.FI, hurtta+elm@ozone.FMI.FI)
#      or  Kari Hurtta <elm@elmme-mailer.org>
#
#
REG	= bin/elmregister $regarg
LIB		=	\$(ELM_ROOT)//$lib
ETC		=	\$(ELM_ROOT)//$etc
BINTARG		=	\$(ELM_ROOT)//$bin
BIN		=	bin
STAGE		=	\$(ELM_ROOT)//$stage_dir
LOCALETARG	=	$localetarget
CHMOD		=	$chmod
STAGEP          = 	\$(ELM_ROOT)//$vardir
$vpathdef
SRCROOT		=	$XXsrcroot
!GROK!THIS!

cat >>Makefile-1 <<'!NO!SUBS!'

DOC		= $(SRCROOT)/doc
CONFTOOL        = $(SRCROOT)/ConfTool
CHARSET		= $(SRCROOT)/charset

all:
lint:
clean:

uninstall_s: 
	$(REG) rm -f $(LOCALETARG) $(LIB)/elm.map.bin/unidata.bin

install_s: $(LIB) $(ETC) $(STAGE) $(ETC)/elm.rc $(LOCALETARG) \
  $(LIB)/elm.map.bin/unidata.bin $(LIB)/elm.map.bin/bindata.bin \
  $(ETC)/elm.mimetypes $(ETC)/elm.mailinglists $(ETC)/elm.aliases \
  libreg 

$(ETC)/elm.rc:	$(LIB)/elmrc-write $(DOC)/elmrc-info 
		$(REG) -s doc {$(LIB)/elmrc-write} -G -I -C {$(DOC)/elmrc-info} \
 -c {$(ETC)/elm.rc.old-values}
		$(REG) $(CHMOD) u=rw,go=r {$@}

$(LIB)/elm.map.bin/unidata.bin: $(LIB) $(LIB)/elm.map.bin \
 $(CHARSET)/UNIDATA/UnicodeData-Latest.txt $(LIB)/elmunidata 
		$(REG) -s unidata {$(LIB)/elmunidata} -G -I -s {$(CHARSET)/UNIDATA/UnicodeData-Latest.txt} 
		$(REG) -s unidata true {$(CHARSET)/UNIDATA/ReadMe.txt}

$(LIB)/elm.map.bin/bindata.bin: $(LIB) $(LIB)/elm.map.bin $(LIB)/elmbindata  \
 $(ETC)/elm.mimecharsets
		$(REG) -s mappings {$(LIB)/elmbindata} -G -I \
  -S {$(CHARSET)/MAPPINGS/ISO8859} -S {$(CHARSET)/MAPPINGS} \
  -S {$(CHARSET)/MAPPINGS/MICSFT} 

$(ETC)/elm.mimecharsets: $(BIN)/elm.mimecharsets $(LIB)/elmcharset \
 $(CONFTOOL)/killsets $(LIB)/elm.map.txt $(ETC)/elm.mimecharsets.NEW
		$(REG) -s mappings {$(LIB)/elmcharset} -G -I {$(CONFTOOL)/killsets} -c \
  -S {$(CHARSET)/MAPPINGS/ISO8859} -S {$(CHARSET)/MAPPINGS} \
  -S {$(CHARSET)/MAPPINGS/MICSFT} {$(BIN)/elm.mimecharsets} 
		$(REG) $(CHMOD) u=rw,go=r {$@}

$(ETC)/elm.mimecharsets.NEW: $(BIN)/elm.mimecharsets \
 $(LIB)/elmcharset $(CONFTOOL)/killsets $(LIB)/elm.map.txt
		$(REG) -s mappings {$(LIB)/elmcharset} -G -I {$(CONFTOOL)/killsets} -w {$@} \
  -S {$(CHARSET)/MAPPINGS/ISO8859} -S {$(CHARSET)/MAPPINGS} \
  -S {$(CHARSET)/MAPPINGS/MICSFT} {$(BIN)/elm.mimecharsets} 

$(ETC)/elm.mimetypes: $(BIN)/elm.mimetypes $(LIB)/elmmimetypes \
 $(ETC)/elm.mimetypes.NEW
	$(REG) -s mappings {$(LIB)/elmmimetypes} -G -c {$(BIN)/elm.mimetypes}
	$(REG) $(CHMOD) u=rw,go=r {$@}

$(ETC)/elm.mimetypes.NEW: $(BIN)/elm.mimetypes $(LIB)/elmmimetypes 
	$(REG) -s mappings {$(LIB)/elmmimetypes} -G -w {$@} \
 {$(BIN)/elm.mimetypes}
	$(REG) $(CHMOD) u=rw,go=r {$@}

$(ETC)/elm.mailinglists: $(BIN)/elm.mailinglists \
 $(LIB)/elmmailinglists $(ETC)/elm.mailinglists.NEW
	$(REG) -s mailinglists {$(LIB)/elmmailinglists} -G -c \
 {$(BIN)/elm.mailinglists} 
	$(REG) $(CHMOD) u=rw,go=r {$@}

$(ETC)/elm.mailinglists.NEW: $(BIN)/elm.mailinglists $(LIB)/elmmailinglists  
	$(REG) -s mailinglists {$(LIB)/elmmailinglists} -G -w {$@} \
 {$(BIN)/elm.mailinglists} 
	$(REG) $(CHMOD) u=rw,go=r {$@}

$(ETC)/elm.aliases: $(BIN)/elm.aliases \
 $(LIB)/elmaliases-write $(ETC)/elm.aliases.NEW convert-old-aliases
	$(REG) -s aliases {$(LIB)/elmaliases-write} -G -c \
 {$(BIN)/elm.aliases} 
	$(REG) $(CHMOD) u=rw,go=r {$@}

convert-old-aliases: $(BINTARG)/newalias
	$(REG) {$(BINTARG)/newalias} -g -q

$(ETC)/elm.aliases.NEW: $(BIN)/elm.aliases $(LIB)/elmaliases-write
	$(REG) -s aliases {$(LIB)/elmaliases-write} -G -w {$@} \
 {$(BIN)/elm.aliases} 
	$(REG) $(CHMOD) u=rw,go=r {$@}


$(ETC)/elm.terminalinfo: $(BIN)/elm.terminalinfo $(LIB)/elmterminal \
 $(ETC)/elm.mimecharsets $(ETC)/elm.terminalinfo.NEW
	$(REG) -s terminal {$(LIB)/elmterminal} -G -c \
 {$(BIN)/elm.terminalinfo}
	$(REG) $(CHMOD) u=rw,go=r {$@}

$(ETC)/elm.terminalinfo.NEW: $(BIN)/elm.terminalinfo \
 $(LIB)/elmterminal $(ETC)/elm.mimecharsets
	$(REG) -s terminal {$(LIB)/elmterminal} -G -w {$@} {$(BIN)/elm.terminalinfo}

$(LIB):
		$(REG) mkdir $(LIB)

$(LIB)/elm.map.bin: 
		$(REG) mkdir $(LIB)/elm.map.bin

$(LIB)/elm.map.txt:
		$(REG) mkdir $(LIB)/elm.map.txt

$(STAGE):	$(STAGEP)
		$(REG) mkdir $(STAGE)

$(STAGEP):
		$(REG) mkdir $(STAGEP)

!NO!SUBS!


case "$d_dlopen_libs" in
define)  
	 aa=
	 if $test "$shared_register" != none ; then
	    aa="$shared_register"
	 fi
cat >>Makefile-1 <<!SUBS!

# Register new libraries and unregister removed libraries
# Also libraries which are not loadable are unregistered
libreg:
	\$(REG) {\$(LIB)/elmlibregister} -G -I -c {\$(ETC)/elm.rc.old-values}
!SUBS!
	for domake in $aa ; do
	    cat >>Makefile-1 <<!SUBS!
	\$(REG) -M "$domake" {\$(LIB)/elmlibregister} -G -I -c {\$(ETC)/elm.rc.old-values} $domake
!SUBS!
	done
	    cat >>Makefile-1 <<'!NO!SUBS!'
	$(REG) -M all -s doc {$(LIB)/elmrc-write} -G -I -C {$(DOC)/elmrc-info} \
 -c {$(ETC)/elm.rc.old-values} -E {$(ETC)/elm.rc.old-values}
!NO!SUBS!
	 ;;
*)	 

cat >>Makefile-1 <<'!NO!SUBS!'

libreg:
!NO!SUBS!
	;;
esac
